function [level, speed]=CollectiveAction(N,Node,alpha)
% This program generate the dynamics of collective action
% N: the population size
% Node: the struct of actors
% alpha: strength difference between strong vs. weak ties

%% Statistics on the initial conditions
active_individuals_this_round=[];
for i=1:N
    if Node(i).threshold<0
        Node(i).active=1;
        active_individuals_this_round=[active_individuals_this_round;i];
    else
        Node(i).active=0;
    end
    
end
level=length(active_individuals_this_round);
%% behavior diffusion starts
speed=[];
con=0;
while con==0
    active_individuals_last_round=active_individuals_this_round;
    Node_has_neighbor_active=[];
    if ~isempty(active_individuals_last_round)
        for i=1:length(active_individuals_last_round)
            n1=active_individuals_last_round(i);
            for j=1:Node(n1).stNums
                n2=Node(n1).st(j);
                if Node(n2).active==0
                    Node(n2).s=Node(n2).s+(1+alpha)/Node(n2).w;
                    Node_has_neighbor_active=[Node_has_neighbor_active;n2];
                end
            end
            for j=1:Node(n1).wtNums
                n2=Node(n1).wt(j);
                if Node(n2).active==0
                    Node(n2).s=Node(n2).s+(1-alpha)/Node(n2).w;
                    Node_has_neighbor_active=[Node_has_neighbor_active;n2];
                end
            end
        end
    end
    Node_has_neighbor_active=unique(Node_has_neighbor_active);
    active_individuals_this_round=[];
    for i=1:length(Node_has_neighbor_active)
        n1=Node_has_neighbor_active(i);
        if Node(n1).s>Node(n1).threshold
            Node(n1).active=1;
            active_individuals_this_round=[active_individuals_this_round;n1];
        end
    end
    a=length(active_individuals_this_round);
    level=level+a;
    speed=[speed;a];
    if a==0
        con=1;
    end
end