clear all
clc
tic
N=5000; % population size
M=20; % number of communities
gamma=3; % power-law exponent 
m=9; % average number of strong ties
n=9; % average number of weak ties
alpha=0.5; 
times=1000; % repeat count towards unique configuration of parameter setting
line_nums=3; % how many lines will display in a plot
x_scales=41; % scales for x-axis

for l=1:line_nums
    threshold_mean=0.3+l/10; % T_mean: strong, intermediate, weak class
    Results(l).level=zeros(x_scales,times);
    Results(l).speed=zeros(x_scales,times);
    for x=1:x_scales
        threshold_std=(x-1)/(x_scales-1); % T_std: 0:0.025:1
        for t=1:times
            % generate network
            Node=ScaleFreeNetwork_CommunityStructure(N,M,m,n,gamma);
            % threshold distribution 
            threshold_distribution=normrnd(threshold_mean,threshold_std,N,1);
            for i=1:N
                Node(i).threshold=threshold_distribution(i);
                Node(i).s=0; % the social influence that i observes
                Node(i).w=(1+alpha)*Node(i).stNums+(1-alpha)*Node(i).wtNums; 
            end
            [level, speed]=CollectiveAction(N,Node,alpha);
            Results(l).level(x,t)=level;
            if ~isempty(speed)
                Results(l).speed(x,t)=mean(speed);
            else
                Results(l).speed(x,t)=0;
            end
            str = sprintf('l=%g :  x=%g :  t=%g :',l,x,t); 
            disp(str);
        end
     end
end

for i=1:line_nums
    for j=1:x_scales
        FinalResults(1).level(j,i)=mean(Results(i).level(j,1:times));
        FinalResults(1).speed(j,i)=mean(Results(i).speed(j,1:times));
    end
end
save threshold_collectivism_without_ICTs.mat FinalResults
toc